
PrefabFiles = {
	"chester",

}

local function MorphSnowChester(inst, dofx)
    inst:AddTag("fridge")
    inst:AddTag("lowcool")

    local leader = inst.components.follower.leader
    if leader then
        inst.components.follower.leader:MorphSnowEyebone()
    end

    inst.AnimState:SetBuild("chester_snow_build")
    inst.ChesterState = "SNOW"
    inst.MiniMapEntity:SetIcon("chestersnow.png")
end

local function CanMorph(inst)
    local clock = GLOBAL.GetWorld().components.clock

    if not clock:IsNight() or clock:GetMoonPhase() ~= "full" or inst.ChesterState ~= "NORMAL" then
        return false, false
    end

    local container = inst.components.container

    local canShadow = true
    local canSnow = true
    local canIce = true

    for i = 1, container:GetNumSlots() do
        local item = container:GetItemInSlot(i)
        
        if not item then
            canShadow = false
            canSnow = false
            canIce = false
            break
        end

        if item.prefab ~= "nightmarefuel" then
            canShadow = false
        end

        if item.prefab ~= "bluegem" then
            canSnow = false
        end

        if item.prefab ~= "ice" then
	    canIce = false
	end
    end
    if canIce then
	canSnow = true
    end
    return canShadow, canSnow
end

local function MorphChester(inst)
    local clock = GLOBAL.GetWorld().components.clock

    if not clock:IsNight() or inst.ChesterState ~= "NORMAL" or clock:GetMoonPhase() ~= "full" then
        return
    end

    local container = inst.components.container

    local canShadow, canSnow = inst:CanMorph()

    if canShadow then
        container:ConsumeByName("nightmarefuel", container:GetNumSlots())
        MorphShadowChester(inst, true)
    elseif canSnow then
        container:ConsumeByName("bluegem", container:GetNumSlots())
	container:ConsumeByName("ice",container:GetNumSlots())
        MorphSnowChester(inst, true)
    end
end

local function CheckForMorph(inst)
    print "CHECK FOR MORPH"
    local shadow, snow = inst:CanMorph()
    if shadow or snow then
        if inst.MorphTask then
            inst.MorphTask:Cancel()
            inst.MorphTask = nil
        end
        inst.MorphTask = inst:DoTaskInTime(6, function(inst)
            inst.sg:GoToState("transition")
        end)
    end
end

function IceChester(inst)
	inst.CanMorph = CanMorph
	inst.MorphChester = MorphChester
	inst.CheckForMorph = CheckForMorph
end

AddPrefabPostInit("chester", IceChester)